// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/loft-sh/api/v4/pkg/apis/storage/v1"
	scheme "github.com/loft-sh/api/v4/pkg/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DevPodEnvironmentTemplatesGetter has a method to return a DevPodEnvironmentTemplateInterface.
// A group's client should implement this interface.
type DevPodEnvironmentTemplatesGetter interface {
	DevPodEnvironmentTemplates() DevPodEnvironmentTemplateInterface
}

// DevPodEnvironmentTemplateInterface has methods to work with DevPodEnvironmentTemplate resources.
type DevPodEnvironmentTemplateInterface interface {
	Create(ctx context.Context, devPodEnvironmentTemplate *v1.DevPodEnvironmentTemplate, opts metav1.CreateOptions) (*v1.DevPodEnvironmentTemplate, error)
	Update(ctx context.Context, devPodEnvironmentTemplate *v1.DevPodEnvironmentTemplate, opts metav1.UpdateOptions) (*v1.DevPodEnvironmentTemplate, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.DevPodEnvironmentTemplate, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.DevPodEnvironmentTemplateList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.DevPodEnvironmentTemplate, err error)
	DevPodEnvironmentTemplateExpansion
}

// devPodEnvironmentTemplates implements DevPodEnvironmentTemplateInterface
type devPodEnvironmentTemplates struct {
	client rest.Interface
}

// newDevPodEnvironmentTemplates returns a DevPodEnvironmentTemplates
func newDevPodEnvironmentTemplates(c *StorageV1Client) *devPodEnvironmentTemplates {
	return &devPodEnvironmentTemplates{
		client: c.RESTClient(),
	}
}

// Get takes name of the devPodEnvironmentTemplate, and returns the corresponding devPodEnvironmentTemplate object, and an error if there is any.
func (c *devPodEnvironmentTemplates) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.DevPodEnvironmentTemplate, err error) {
	result = &v1.DevPodEnvironmentTemplate{}
	err = c.client.Get().
		Resource("devpodenvironmenttemplates").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DevPodEnvironmentTemplates that match those selectors.
func (c *devPodEnvironmentTemplates) List(ctx context.Context, opts metav1.ListOptions) (result *v1.DevPodEnvironmentTemplateList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.DevPodEnvironmentTemplateList{}
	err = c.client.Get().
		Resource("devpodenvironmenttemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested devPodEnvironmentTemplates.
func (c *devPodEnvironmentTemplates) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("devpodenvironmenttemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a devPodEnvironmentTemplate and creates it.  Returns the server's representation of the devPodEnvironmentTemplate, and an error, if there is any.
func (c *devPodEnvironmentTemplates) Create(ctx context.Context, devPodEnvironmentTemplate *v1.DevPodEnvironmentTemplate, opts metav1.CreateOptions) (result *v1.DevPodEnvironmentTemplate, err error) {
	result = &v1.DevPodEnvironmentTemplate{}
	err = c.client.Post().
		Resource("devpodenvironmenttemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(devPodEnvironmentTemplate).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a devPodEnvironmentTemplate and updates it. Returns the server's representation of the devPodEnvironmentTemplate, and an error, if there is any.
func (c *devPodEnvironmentTemplates) Update(ctx context.Context, devPodEnvironmentTemplate *v1.DevPodEnvironmentTemplate, opts metav1.UpdateOptions) (result *v1.DevPodEnvironmentTemplate, err error) {
	result = &v1.DevPodEnvironmentTemplate{}
	err = c.client.Put().
		Resource("devpodenvironmenttemplates").
		Name(devPodEnvironmentTemplate.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(devPodEnvironmentTemplate).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the devPodEnvironmentTemplate and deletes it. Returns an error if one occurs.
func (c *devPodEnvironmentTemplates) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("devpodenvironmenttemplates").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *devPodEnvironmentTemplates) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("devpodenvironmenttemplates").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched devPodEnvironmentTemplate.
func (c *devPodEnvironmentTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.DevPodEnvironmentTemplate, err error) {
	result = &v1.DevPodEnvironmentTemplate{}
	err = c.client.Patch(pt).
		Resource("devpodenvironmenttemplates").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
